﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using System.Collections;
using samplebrowser.Models;
using System.ComponentModel.DataAnnotations;
using Syncfusion.Linq;

namespace ejGridASPCore.Controllers
{
    public partial class HomeController : Controller
    {
        public IActionResult Index()
        {
            if (order.Count() == 0)
                BindDataSource();
            return View();
        }
        public static List<AlarmModel> alaram = new List<AlarmModel>();
        public static List<Orders> order = new List<Orders>();
        public void BindDataSource()
        {
            int code = 10000;
            for (int i = 1; i < 10; i++)
            {
                order.Add(new Orders((code + 1), "ALFKI", 1, 2.3 * i, new DateTime(1991, 05, 15), "Berlin", new List<AlarmModel>() { new AlarmModel() { DetailsID=1,  Date = new DateTime(), Description = "This is Hierarchy Level" }, new AlarmModel() { DetailsID = 2, Date = new DateTime(1991, 05, 15), Description = "This is Hierarchy Level" } }));
                order.Add(new Orders((code + 2), "ANATR", 2, 3.3 * i, new DateTime(1990, 04, 04), "Madrid", new List<AlarmModel>() { new AlarmModel() { DetailsID = 1, Date = new DateTime(), Description = "This is Hierarchy Level" }, new AlarmModel() { DetailsID = 2, Date = new DateTime(1991, 05, 15), Description = "This is Hierarchy Level" } }));
                order.Add(new Orders((code + 3), "ANTON", 3, 4.3 * i, new DateTime(1957, 11, 30), "Cholchester", new List<AlarmModel>() { new AlarmModel() { DetailsID = 1, Date = new DateTime(), Description = "This is Hierarchy Level" }, new AlarmModel() { DetailsID = 2, Date = new DateTime(1991, 05, 15), Description = "This is Hierarchy Level" } }));
                order.Add(new Orders((code + 4), "BLONP", 4, 5.3 * i, new DateTime(1930, 10, 22), "Marseille", new List<AlarmModel>() { new AlarmModel() { DetailsID = 1, Date = new DateTime(), Description = "This is Hierarchy Level" }, new AlarmModel() { DetailsID = 2, Date = new DateTime(1991, 05, 15), Description = "This is Hierarchy Level" } }));
                order.Add(new Orders((code + 5), "BOLID", 5, 6.3 * i, new DateTime(1953, 02, 18), "Tsawassen", new List<AlarmModel>() { new AlarmModel() { DetailsID = 1, Date = new DateTime(), Description = "This is Hierarchy Level" }, new AlarmModel() { DetailsID = 2, Date = new DateTime(1991, 05, 15), Description = "This is Hierarchy Level" } }));
                code += 5;
            }
        }
        public IActionResult GetIndexData([FromBody]DataManager dm)
        {
            IEnumerable datasource = order;//.Skip(dm.Skip).Take(dm.Take).ToList();  //_context.Pilots.Skip(dm.Skip).Take(dm.Take).Include(p => p.Union).
                                                                    //         Include(p => p.Masterlist).Include(p => p.Instructor).ToList();       //Second Trip kills this query because DM is NULLLLLLL
            DataOperations operation = new DataOperations();
            int count = datasource.AsQueryable().Count(); ;
            if (dm.Select != null)//select required columns
                datasource = operation.PerformSelect(datasource, dm.Select);
            if (dm.Skip >= 0)//for paging
                datasource = operation.PerformSkip(datasource, dm.Skip);
            if (dm.Take > 0)//for paging
                datasource = operation.PerformTake(datasource, dm.Take);

            return Json(new { result = datasource, count = count });
        }
        public class Orders
        {
            public Orders()
            {

            }
            public Orders(int ID, string CustomerId, int EmployeeId, double Freight, DateTime OrderDate, string AdresseTyp, IList<AlarmModel> alarm)
            {
                this.ID = ID;
                this.CustomerID = CustomerId;
                this.EmployeeID = EmployeeId;
                this.Freight = Freight;
                this.OrderDate = OrderDate;
                this.AdresseTyp = AdresseTyp;
                this.Alarms = alarm;
            }
            [Required]
            public int ID { get; set; }
            public string CustomerID { get; set; }
            public int EmployeeID { get; set; }
            public double Freight { get; set; }
            public DateTime OrderDate { get; set; }
            public string AdresseTyp { get; set; }
            public IList<AlarmModel> Alarms { get; set; }
        }
        public class AlarmModel
        {
            public long DetailsID { get; set; }
            public string Description { get; set; }
            public DateTime Date { get; set; }
        }
    }
}
