#region Copyright Syncfusion Inc. 2001 - 2016
// Copyright Syncfusion Inc. 2001 - 2016. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace samplebrowser.Models
{
    public partial class Orders
    {
        [Key]
        public int OrderID { get; set; }
        public string CustomerID { get; set; }
        public int EmployeeID { get; set; }
        public decimal? Freight { get; set; }
        public DateTime? OrderDate { get; set; }
        public string ShipCity { get; set; }
    }
    public partial class Employees
    {
        [Key]
        public int EmployeeID { get; set; }
        public string CustomerID
        {
            get; set;
        }
        public decimal? FirstName { get; set; }
        public DateTime? LastName { get; set; }
        public string BirthDate { get; set; }
    }
    public partial class Customers
    {
        [Key]
        public string CustomerID
        {
            get; set;
        }
        public string CompanyName
        {
            get; set;
        }
        public string ContactName { get; set; }
        public string ContactTitle { get; set; }
        public string City { get; set; }
    }
}
